diff -c ../zip19i/deflate.c ./deflate.c
*** ../zip19i/deflate.c	Tue Nov  3 21:07:54 1992
--- ./deflate.c	Fri Sep 10 03:41:50 1993
***************
*** 1,11 ****
  /*
  
!  Copyright (C) 1990-1992 Mark Adler, Richard B. Wales, Jean-loup Gailly,
   Kai Uwe Rommel and Igor Mandrichenko.
   Permission is granted to any individual or institution to use, copy, or
!  redistribute this software so long as all of the original files are included
!  unmodified, that it is not sold for profit, and that this copyright notice
!  is retained.
  
  */
  
--- 1,10 ----
  /*
  
!  Copyright (C) 1990-1993 Mark Adler, Richard B. Wales, Jean-loup Gailly,
   Kai Uwe Rommel and Igor Mandrichenko.
   Permission is granted to any individual or institution to use, copy, or
!  redistribute this software so long as all of the original files are included,
!  that it is not sold for profit, and that this copyright notice is retained.
  
  */
  
***************
*** 25,31 ****
   *
   *      The most straightforward technique turns out to be the fastest for
   *      most input files: try all possible matches and select the longest.
!  *      The key feature is of this algorithm is that insertions into the string
   *      dictionary are very simple and thus fast, and deletions are avoided
   *      completely. Insertions are performed at each input character, whereas
   *      string matches are performed only when the previous match ends. So it
--- 24,30 ----
   *
   *      The most straightforward technique turns out to be the fastest for
   *      most input files: try all possible matches and select the longest.
!  *      The key feature of this algorithm is that insertions into the string
   *      dictionary are very simple and thus fast, and deletions are avoided
   *      completely. Insertions are performed at each input character, whereas
   *      string matches are performed only when the previous match ends. So it
***************
*** 120,125 ****
--- 119,127 ----
  #if defined(ASMV) && !defined(MSDOS) && defined(DYN_ALLOC)
    error: DYN_ALLOC not yet supported in match.s
  #endif
+ #if defined(MSDOS) && !defined(__32BIT__)
+ #  define MAXSEG_64K
+ #endif
  
  /* ===========================================================================
   * Local data used by the "longest match" routines.
***************
*** 160,166 ****
    Pos    * near prev   = NULL;
    Pos    * near head;
  #endif
! ulg window_size = (ulg)2*WSIZE;
  /* window size, 2*WSIZE except for MMAP or BIG_MEM, where it is the
   * input file length plus MIN_LOOKAHEAD.
   */
--- 162,168 ----
    Pos    * near prev   = NULL;
    Pos    * near head;
  #endif
! ulg window_size;
  /* window size, 2*WSIZE except for MMAP or BIG_MEM, where it is the
   * input file length plus MIN_LOOKAHEAD.
   */
***************
*** 170,175 ****
--- 172,180 ----
   * negative when the window is moved backwards.
   */
  
+ local int sliding;
+ /* Set to false when the input file is already in memory */
+ 
  local unsigned ins_h;  /* hash index of string to be inserted */
  
  #define H_SHIFT  ((HASH_BITS+MIN_MATCH-1)/MIN_MATCH)
***************
*** 196,205 ****
  
  local unsigned int max_lazy_match;
  /* Attempt to find a better match only when the current match is strictly
!  * smaller than this value.
   */
  
! int near good_match;
  /* Use a faster search when the previous match is longer than this */
  
  
--- 201,216 ----
  
  local unsigned int max_lazy_match;
  /* Attempt to find a better match only when the current match is strictly
!  * smaller than this value. This mechanism is used only for compression
!  * levels >= 4.
   */
+ #define max_insert_length  max_lazy_match
+ /* Insert new strings in the hash table only if the match length
+  * is not greater than this length. This saves time but degrades compression.
+  * max_insert_length is used only for compression levels <= 3.
+  */
  
! unsigned near good_match;
  /* Use a faster search when the previous match is longer than this */
  
  
***************
*** 216,226 ****
     ush max_chain;
  } config;
  
- #if defined(ASMV) && !defined(FULL_SEARCH)
- # define FULL_SEARCH
-   /* not yet had time to update the asm code, sorry */
- #endif
- 
  #ifdef  FULL_SEARCH
  # define nice_match MAX_MATCH
  #else
--- 227,232 ----
***************
*** 230,259 ****
  local config configuration_table[10] = {
  /*      good lazy nice chain */
  /* 0 */ {0,    0,  0,    0},  /* store only */
! /* 1 */ {4,    4, 16,   16},  /* maximum speed */
! /* 2 */ {6,    8, 16,   16},
! /* 3 */ {8,   16, 32,   32},
! /* 4 */ {8,   16, 64,   64},
! /* 5 */ {8,   16, 128, 128},
! /* 6 */ {8,   32, 128, 256},
! /* 7 */ {8,   64, 128, 512},
  /* 8 */ {32, 128, 258, 1024},
  /* 9 */ {32, 258, 258, 4096}}; /* maximum compression */
  
! /* Note: the current code requires max_lazy >= MIN_MATCH and max_chain >= 4
!  * but these restrictions can easily be removed at a small cost.
   */
  
  #define EQUAL 0
  /* result of memcmp for equal strings */
  
  /* ===========================================================================
!  *  Prototypes for local functions. Use asm version by default for
!  *  MSDOS but not Unix. However the asm version version is recommended
!  *  for 386 Unix.
   */
  
  local void fill_window   OF((void));
        int  longest_match OF((IPos cur_match));
  #ifdef ASMV
        void match_init OF((void)); /* asm code initialization */
--- 236,267 ----
  local config configuration_table[10] = {
  /*      good lazy nice chain */
  /* 0 */ {0,    0,  0,    0},  /* store only */
! /* 1 */ {4,    4,  8,    4},  /* maximum speed, no lazy matches */
! /* 2 */ {4,    5, 16,    8},
! /* 3 */ {4,    6, 32,   32},
! 
! /* 4 */ {4,    4, 16,   16},  /* lazy matches */
! /* 5 */ {8,   16, 32,   32},
! /* 6 */ {8,   16, 128, 128},
! /* 7 */ {8,   32, 128, 256},
  /* 8 */ {32, 128, 258, 1024},
  /* 9 */ {32, 258, 258, 4096}}; /* maximum compression */
  
! /* Note: the deflate() code requires max_lazy >= MIN_MATCH and max_chain >= 4
!  * For deflate_fast() (levels <= 3) good is ignored and lazy has a different
!  * meaning.
   */
  
  #define EQUAL 0
  /* result of memcmp for equal strings */
  
  /* ===========================================================================
!  *  Prototypes for local functions.
   */
  
  local void fill_window   OF((void));
+ local ulg deflate_fast   OF((void));
+ 
        int  longest_match OF((IPos cur_match));
  #ifdef ASMV
        void match_init OF((void)); /* asm code initialization */
***************
*** 263,271 ****
  local  void check_match OF((IPos start, IPos match, int length));
  #endif
  
- #define MIN(a,b) ((a) <= (b) ? (a) : (b))
- /* The arguments must not have side effects. */
- 
  /* ===========================================================================
   * Update a hash value with the given input byte
   * IN  assertion: all calls to to UPDATE_HASH are made with consecutive
--- 271,276 ----
***************
*** 289,294 ****
--- 294,305 ----
  
  /* ===========================================================================
   * Initialize the "longest match" routines for a new file
+  *
+  * IN assertion: window_size is > 0 if the input file is already read or
+  *    mmap'ed in the window[] array, 0 otherwise. In the first case,
+  *    window_size is sufficient to contain the whole input file plus
+  *    MIN_LOOKAHEAD bytes (to avoid referencing memory beyond the end
+  *    of window[] when looking for matches towards the end).
   */
  void lm_init (pack_level, flags)
      int pack_level; /* 0: store, 1: best speed, 9: best compression */
***************
*** 298,309 ****
  
      if (pack_level < 1 || pack_level > 9) error("bad pack level");
  
      /* Use dynamic allocation if compiler does not like big static arrays: */
  #ifdef DYN_ALLOC
      if (window == NULL) {
          window = (uch*) fcalloc(WSIZE,   2*sizeof(uch));
          if (window == NULL) err(ZE_MEM, "window allocation");
-         window_size = (ulg)2*WSIZE;
      }
      if (prev == NULL) {
          prev   = (Pos*) fcalloc(WSIZE,     sizeof(Pos));
--- 309,328 ----
  
      if (pack_level < 1 || pack_level > 9) error("bad pack level");
  
+     /* Do not slide the window if the whole input is already in memory
+      * (window_size > 0)
+      */
+     sliding = 0;
+     if (window_size == 0L) {
+         sliding = 1;
+         window_size = (ulg)2L*WSIZE;
+     }
+ 
      /* Use dynamic allocation if compiler does not like big static arrays: */
  #ifdef DYN_ALLOC
      if (window == NULL) {
          window = (uch*) fcalloc(WSIZE,   2*sizeof(uch));
          if (window == NULL) err(ZE_MEM, "window allocation");
      }
      if (prev == NULL) {
          prev   = (Pos*) fcalloc(WSIZE,     sizeof(Pos));
***************
*** 313,324 ****
          }
      }
  #endif /* DYN_ALLOC */
! #ifdef ASMV
!     match_init(); /* initialize the asm code */
! #endif
!     /* Initialize the hash table. */
!     for (j = 0;  j < HASH_SIZE; j++) head[j] = NIL;
!     /* prev will be initialized on the fly */
  
      /* Set the default configuration parameters:
       */
--- 332,343 ----
          }
      }
  #endif /* DYN_ALLOC */
! 
!     /* Initialize the hash table (avoiding 64K overflow for 16 bit systems).
!      * prev[] will be initialized on the fly.
!      */
!     head[HASH_SIZE-1] = NIL;
!     memset((char*)head, NIL, (unsigned)(HASH_SIZE-1)*sizeof(*head));
  
      /* Set the default configuration parameters:
       */
***************
*** 337,349 ****
  
      strstart = 0;
      block_start = 0L;
  
! #if defined(MSDOS) && !defined(__32BIT__)
!     /* Can't read a 64K block under MSDOS */
!     lookahead = read_buf((char*)window, (unsigned)WSIZE);
! #else
!     lookahead = read_buf((char*)window, 2*WSIZE);
  #endif
      if (lookahead == 0 || lookahead == (unsigned)EOF) {
         eofile = 1, lookahead = 0;
         return;
--- 356,371 ----
  
      strstart = 0;
      block_start = 0L;
+ #ifdef ASMV
+     match_init(); /* initialize the asm code */
+ #endif
  
!     j = WSIZE;
! #ifndef MAXSEG_64K
!     if (sizeof(int) > 2) j <<= 1; /* Can read 64K in one step */
  #endif
+     lookahead = (*read_buf)((char*)window, j);
+ 
      if (lookahead == 0 || lookahead == (unsigned)EOF) {
         eofile = 1, lookahead = 0;
         return;
***************
*** 362,367 ****
--- 384,407 ----
  }
  
  /* ===========================================================================
+  * Free the window and hash table
+  */
+ void lm_free()
+ {
+ #ifdef DYN_ALLOC
+     if (window != NULL) {
+         fcfree(window);
+         window = NULL;
+     }
+     if (prev != NULL) {
+         fcfree(prev);
+         fcfree(head);
+         prev = head = NULL;
+     }
+ #endif /* DYN_ALLOC */
+ }
+ 
+ /* ===========================================================================
   * Set match_start to the longest match starting at the given string and
   * return its length. Matches shorter or equal to prev_length are discarded,
   * in which case the result is equal to prev_length and match_start is
***************
*** 372,396 ****
  #ifndef ASMV
  /* For MSDOS, OS/2 and 386 Unix, an optimized version is in match.asm or
   * match.s. The code is functionally equivalent, so you can use the C version
!  * if desired.
   */
  int longest_match(cur_match)
      IPos cur_match;                             /* current match */
  {
      unsigned chain_length = max_chain_length;   /* max hash chain length */
      register uch *scan = window + strstart;     /* current string */
!     register uch *match = scan;                 /* matched string */
      register int len;                           /* length of current match */
      int best_len = prev_length;                 /* best match length so far */
      IPos limit = strstart > (IPos)MAX_DIST ? strstart - (IPos)MAX_DIST : NIL;
      /* Stop when cur_match becomes <= limit. To simplify the code,
       * we prevent matches with the string of window index 0.
       */
  #ifdef UNALIGNED_OK
      register ush scan_start = *(ush*)scan;
      register ush scan_end   = *(ush*)(scan+best_len-1);
  #else
!     register uch scan_start = *scan;
      register uch scan_end1  = scan[best_len-1];
      register uch scan_end   = scan[best_len];
  #endif
--- 412,449 ----
  #ifndef ASMV
  /* For MSDOS, OS/2 and 386 Unix, an optimized version is in match.asm or
   * match.s. The code is functionally equivalent, so you can use the C version
!  * if desired.  A 68000 version is in amiga/match_68.a -- this could be used
!  * with other 68000 based systems such as Macintosh with a little effort.
   */
  int longest_match(cur_match)
      IPos cur_match;                             /* current match */
  {
      unsigned chain_length = max_chain_length;   /* max hash chain length */
      register uch *scan = window + strstart;     /* current string */
!     register uch *match;                        /* matched string */
      register int len;                           /* length of current match */
      int best_len = prev_length;                 /* best match length so far */
      IPos limit = strstart > (IPos)MAX_DIST ? strstart - (IPos)MAX_DIST : NIL;
      /* Stop when cur_match becomes <= limit. To simplify the code,
       * we prevent matches with the string of window index 0.
       */
+ 
+ /* The code is optimized for HASH_BITS >= 8 and MAX_MATCH-2 multiple of 16.
+  * It is easy to get rid of this optimization if necessary.
+  */
+ #if HASH_BITS < 8 || MAX_MATCH != 258
+    error: Code too clever
+ #endif
+ 
  #ifdef UNALIGNED_OK
+     /* Compare two bytes at a time. Note: this is not always beneficial.
+      * Try with and without -DUNALIGNED_OK to check.
+      */
+     register uch *strend = window + strstart + MAX_MATCH - 1;
      register ush scan_start = *(ush*)scan;
      register ush scan_end   = *(ush*)(scan+best_len-1);
  #else
!     register uch *strend = window + strstart + MAX_MATCH;
      register uch scan_end1  = scan[best_len-1];
      register uch scan_end   = scan[best_len];
  #endif
***************
*** 399,404 ****
--- 452,458 ----
      if (prev_length >= good_match) {
          chain_length >>= 2;
      }
+     Assert(strstart <= window_size-MIN_LOOKAHEAD, "insufficient lookahead");
  
      do {
          Assert(cur_match < strstart, "no future");
***************
*** 407,450 ****
          /* Skip to next match if the match length cannot increase
           * or if the match length is less than 2:
           */
! #if (defined(UNALIGNED_OK) && HASH_BITS >= 8)
!         /* This code assumes sizeof(unsigned short) == 2 and
!          * sizeof(unsigned long) == 4. Do not use UNALIGNED_OK if your
!          * compiler uses different sizes.
           */
          if (*(ush*)(match+best_len-1) != scan_end ||
              *(ush*)match != scan_start) continue;
  
-         len = MIN_MATCH - 4;
          /* It is not necessary to compare scan[2] and match[2] since they are
           * always equal when the other bytes match, given that the hash keys
!          * are equal and that HASH_BITS >= 8.
!          */
!         do {} while ((len+=4) < MAX_MATCH-3 &&
!                      *(ulg*)(scan+len) == *(ulg*)(match+len));
!         /* The funny do {} generates better code for most compilers */
  
!         if (*(ush*)(scan+len) == *(ush*)(match+len)) len += 2;
!         if (scan[len] == match[len]) len++;
  
  #else /* UNALIGNED_OK */
!         if (match[best_len] != scan_end ||
! /*          match[best_len-1] != scan_end1 || */ *match != scan_start)
!            continue;
!         /* It is not necessary to compare scan[1] and match[1] since they
           * are always equal when the other bytes match, given that
!          * the hash keys are equal and that h_shift+8 <= HASH_BITS,
!          * that is, when the last byte is entirely included in the hash key.
!          * The condition is equivalent to
!          *       (HASH_BITS+2)/3 + 8 <= HASH_BITS
!          * or: HASH_BITS >= 13
           */
! #if HASH_BITS >= 13
!         len = 1;
! #else
!         len = 0;
! #endif
!         do {} while (++len < MAX_MATCH && scan[len] == match[len]);
  
  #endif /* UNALIGNED_OK */
  
--- 461,525 ----
          /* Skip to next match if the match length cannot increase
           * or if the match length is less than 2:
           */
! #if (defined(UNALIGNED_OK) && MAX_MATCH == 258)
!         /* This code assumes sizeof(unsigned short) == 2. Do not use
!          * UNALIGNED_OK if your compiler uses a different size.
           */
          if (*(ush*)(match+best_len-1) != scan_end ||
              *(ush*)match != scan_start) continue;
  
          /* It is not necessary to compare scan[2] and match[2] since they are
           * always equal when the other bytes match, given that the hash keys
!          * are equal and that HASH_BITS >= 8. Compare 2 bytes at a time at
!          * strstart+3, +5, ... up to strstart+257. We check for insufficient
!          * lookahead only every 4th comparison; the 128th check will be made
!          * at strstart+257. If MAX_MATCH-2 is not a multiple of 8, it is
!          * necessary to put more guard bytes at the end of the window, or
!          * to check more often for insufficient lookahead.
!          */
!         scan++, match++;
!         do {
!         } while (*(ush*)(scan+=2) == *(ush*)(match+=2) &&
!                  *(ush*)(scan+=2) == *(ush*)(match+=2) &&
!                  *(ush*)(scan+=2) == *(ush*)(match+=2) &&
!                  *(ush*)(scan+=2) == *(ush*)(match+=2) &&
!                  scan < strend);
!         /* The funny "do {}" generates better code on most compilers */
! 
!         /* Here, scan <= window+strstart+257 */
!         Assert(scan <= window+(unsigned)(window_size-1), "wild scan");
!         if (*scan == *match) scan++;
  
!         len = (MAX_MATCH - 1) - (int)(strend-scan);
!         scan = strend - (MAX_MATCH-1);
  
  #else /* UNALIGNED_OK */
! 
!         if (match[best_len]   != scan_end  ||
!             match[best_len-1] != scan_end1 ||
!             *match            != *scan     ||
!             *++match          != scan[1])      continue;
! 
!         /* The check at best_len-1 can be removed because it will be made
!          * again later. (This heuristic is not always a win.)
!          * It is not necessary to compare scan[2] and match[2] since they
           * are always equal when the other bytes match, given that
!          * the hash keys are equal and that HASH_BITS >= 8.
           */
!         scan += 2, match++;
! 
!         /* We check for insufficient lookahead only every 8th comparison;
!          * the 256th check will be made at strstart+258.
!          */
!         do {
!         } while (*++scan == *++match && *++scan == *++match &&
!                  *++scan == *++match && *++scan == *++match &&
!                  *++scan == *++match && *++scan == *++match &&
!                  *++scan == *++match && *++scan == *++match &&
!                  scan < strend);
! 
!         len = MAX_MATCH - (int)(strend - scan);
!         scan = strend - MAX_MATCH;
  
  #endif /* UNALIGNED_OK */
  
***************
*** 459,466 ****
              scan_end   = scan[best_len];
  #endif
          }
!     } while (--chain_length != 0 &&
!              (cur_match = prev[cur_match & WMASK]) > limit);
  
      return best_len;
  }
--- 534,541 ----
              scan_end   = scan[best_len];
  #endif
          }
!     } while ((cur_match = prev[cur_match & WMASK]) > limit
!              && --chain_length != 0);
  
      return best_len;
  }
***************
*** 494,499 ****
--- 569,575 ----
  /* ===========================================================================
   * Fill the window when the lookahead becomes insufficient.
   * Updates strstart and lookahead, and sets eofile if end of input file.
+  *
   * IN assertion: lookahead < MIN_LOOKAHEAD && strstart + lookahead > 0
   * OUT assertions: at least one byte has been read, or eofile is set;
   *    file reads are performed for at least two bytes (required for the
***************
*** 505,531 ****
      unsigned more = (unsigned)(window_size - (ulg)lookahead - (ulg)strstart);
      /* Amount of free space at the end of the window. */
  
!     /* If the window is full, move the upper half to the lower one to make
!      * room in the upper half.
       */
      if (more == (unsigned)EOF) {
          /* Very unlikely, but possible on 16 bit machine if strstart == 0
           * and lookahead == 1 (input done one byte at time)
           */
          more--;
!     } else if (more <= 1) {
          /* By the IN assertion, the window is not empty so we can't confuse
           * more == 0 with more == 64K on a 16 bit machine.
           */
-         Assert(window_size == (ulg)2*WSIZE, "no sliding with BIG_MEM");
- 
          memcpy((char*)window, (char*)window+WSIZE, (unsigned)WSIZE);
          match_start -= WSIZE;
!         strstart    -= WSIZE;
!         /* strstart - WSIZE >= WSIZE - 1 - lookahead >= WSIZE - MIN_LOOKAHEAD
!          * so we now have strstart >= MAX_DIST:
!          */
!         Assert (strstart >= MAX_DIST, "window slide too early");
          block_start -= (long) WSIZE;
  
          for (n = 0; n < HASH_SIZE; n++) {
--- 581,608 ----
      unsigned more = (unsigned)(window_size - (ulg)lookahead - (ulg)strstart);
      /* Amount of free space at the end of the window. */
  
!     /* If the window is almost full and there is insufficient lookahead,
!      * move the upper half to the lower one to make room in the upper half.
       */
      if (more == (unsigned)EOF) {
          /* Very unlikely, but possible on 16 bit machine if strstart == 0
           * and lookahead == 1 (input done one byte at time)
           */
          more--;
! 
!     /* For MMAP or BIG_MEM, the whole input file is already in memory
!      * so we must not perform sliding. We must however call file_read
!      * in order to compute the crc, update lookahead and possibly set eofile.
!      */
!     } else if (strstart >= WSIZE+MAX_DIST && sliding) {
! 
          /* By the IN assertion, the window is not empty so we can't confuse
           * more == 0 with more == 64K on a 16 bit machine.
           */
          memcpy((char*)window, (char*)window+WSIZE, (unsigned)WSIZE);
          match_start -= WSIZE;
!         strstart    -= WSIZE; /* we now have strstart >= MAX_DIST: */
! 
          block_start -= (long) WSIZE;
  
          for (n = 0; n < HASH_SIZE; n++) {
***************
*** 543,553 ****
          if (verbose) putc('.', stderr);
      }
      /* At this point, more >= 2 */
!     n = read_buf((char*)window+strstart+lookahead, more);
!     if (n == 0 || n == (unsigned)EOF) {
!         eofile = 1;
!     } else {
!         lookahead += n;
      }
  }
  
--- 620,632 ----
          if (verbose) putc('.', stderr);
      }
      /* At this point, more >= 2 */
!     if (!eofile) {
!         n = (*read_buf)((char*)window+strstart+lookahead, more);
!         if (n == 0 || n == (unsigned)EOF) {
!             eofile = 1;
!         } else {
!             lookahead += n;
!         }
      }
  }
  
***************
*** 560,569 ****
                  (char*)NULL, (long)strstart - block_start, (eof))
  
  /* ===========================================================================
!  * Processes a new input file and return its compressed length.
   */
! #ifdef NO_LAZY
! ulg deflate()
  {
      IPos hash_head; /* head of the hash chain */
      int flush;      /* set if current block must be flushed */
--- 639,650 ----
                  (char*)NULL, (long)strstart - block_start, (eof))
  
  /* ===========================================================================
!  * Processes a new input file and return its compressed length. This
!  * function does not perform lazy evaluationof matches and inserts
!  * new strings in the dictionary only for unmatched strings or for short
!  * matches. It is used only for the fast compression options.
   */
! local ulg deflate_fast()
  {
      IPos hash_head; /* head of the hash chain */
      int flush;      /* set if current block must be flushed */
***************
*** 594,615 ****
              flush = ct_tally(strstart-match_start, match_length - MIN_MATCH);
  
              lookahead -= match_length;
!             match_length--; /* string at strstart already in hash table */
!             do {
!                 strstart++;
!                 INSERT_STRING(strstart, hash_head);
!                 /* strstart never exceeds WSIZE-MAX_MATCH, so there are
!                  * always MIN_MATCH bytes ahead. If lookahead < MIN_MATCH
!                  * these bytes are garbage, but it does not matter since the
!                  * next lookahead bytes will always be emitted as literals.
!                  */
!             } while (--match_length != 0);
          } else {
              /* No match, output a literal byte */
              flush = ct_tally (0, window[strstart]);
              lookahead--;
          }
-         strstart++; 
          if (flush) FLUSH_BLOCK(0), block_start = strstart;
  
          /* Make sure that we always have enough lookahead, except
--- 675,712 ----
              flush = ct_tally(strstart-match_start, match_length - MIN_MATCH);
  
              lookahead -= match_length;
! 
!             /* Insert new strings in the hash table only if the match length
!              * is not too large. This saves time but degrades compression.
!              */
!             if (match_length <= max_insert_length) {
!                 match_length--; /* string at strstart already in hash table */
!                 do {
!                     strstart++;
!                     INSERT_STRING(strstart, hash_head);
!                     /* strstart never exceeds WSIZE-MAX_MATCH, so there are
!                      * always MIN_MATCH bytes ahead. If lookahead < MIN_MATCH
!                      * these bytes are garbage, but it does not matter since
!                      * the next lookahead bytes will be emitted as literals.
!                      */
!                 } while (--match_length != 0);
!                 strstart++; 
!             } else {
!                 strstart += match_length;
!                 match_length = 0;
!                 ins_h = window[strstart];
!                 UPDATE_HASH(ins_h, window[strstart+1]);
! #if MIN_MATCH != 3
!                 Call UPDATE_HASH() MIN_MATCH-3 more times
! #endif
!             }
          } else {
              /* No match, output a literal byte */
+             Tracevv((stderr,"%c",window[strstart]));
              flush = ct_tally (0, window[strstart]);
              lookahead--;
+             strstart++; 
          }
          if (flush) FLUSH_BLOCK(0), block_start = strstart;
  
          /* Make sure that we always have enough lookahead, except
***************
*** 622,628 ****
      }
      return FLUSH_BLOCK(1); /* eof */
  }
! #else /* LAZY */
  /* ===========================================================================
   * Same as above, but achieves better compression. We use a lazy
   * evaluation for matches: a match is finally adopted only if there is
--- 719,725 ----
      }
      return FLUSH_BLOCK(1); /* eof */
  }
! 
  /* ===========================================================================
   * Same as above, but achieves better compression. We use a lazy
   * evaluation for matches: a match is finally adopted only if there is
***************
*** 639,644 ****
--- 736,743 ----
      extern ulg isize;        /* byte length of input file, for debug only */
  #endif
  
+     if (level <= 3) return deflate_fast(); /* optimized for speed */
+ 
      /* Process the input block. */
      while (lookahead != 0) {
          /* Insert the string window[strstart .. strstart+2] in the
***************
*** 729,732 ****
  
      return FLUSH_BLOCK(1); /* eof */
  }
! #endif /* LAZY */
--- 828,831 ----
  
      return FLUSH_BLOCK(1); /* eof */
  }
! 
